"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _set = require("babel-runtime/core-js/set");

var _set2 = _interopRequireDefault(_set);

exports.default = ReduxTaxi;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* ReduxTaxi
*
* Returns the ReduxTaxi instance to be instantiated server-side and passed to the middleware.
*
**/

function ReduxTaxi() {
    var registeredActions = new _set2.default();
    var promises = [];

    return {
        register: function register(actionType) {
            registeredActions.add(actionType);
        },
        getRegisteredActions: function getRegisteredActions() {
            return registeredActions;
        },
        isRegistered: function isRegistered(actionType) {
            return registeredActions.has(actionType);
        },
        collectPromise: function collectPromise(promise) {
            promises.push(promise);
        },
        getAllPromises: function getAllPromises() {
            return promises;
        }
    };
}