'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = registerAsyncActions;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
* RegisterAsyncActions
*
* Registers the asynchronous actions passed in so that
* the server:
* a) Does not throw an error for expected asynchronous actions
* b) Waits to render the server side markup (for these actions to resolve)
*
**/
function registerAsyncActions() {
    for (var _len = arguments.length, actionTypes = Array(_len), _key = 0; _key < _len; _key++) {
        actionTypes[_key] = arguments[_key];
    }

    return function (DecoratedComponent) {
        var _class, _temp;

        return _temp = _class = function (_React$Component) {
            (0, _inherits3.default)(AsyncDecorator, _React$Component);

            function AsyncDecorator(props, context) {
                (0, _classCallCheck3.default)(this, AsyncDecorator);

                var _this = (0, _possibleConstructorReturn3.default)(this, (AsyncDecorator.__proto__ || (0, _getPrototypeOf2.default)(AsyncDecorator)).call(this, props, context));

                if (context.reduxTaxi) {
                    actionTypes.forEach(function (actionType) {
                        context.reduxTaxi.register(actionType);
                    });
                }
                return _this;
            }

            (0, _createClass3.default)(AsyncDecorator, [{
                key: 'render',
                value: function render() {
                    return _react2.default.createElement(DecoratedComponent, this.props);
                }
            }]);
            return AsyncDecorator;
        }(_react2.default.Component), _class.contextTypes = {
            reduxTaxi: _propTypes2.default.object // not required because we don't define it for client context
        }, _temp;
    };
}